package Model;

import java.awt.Point;
import java.awt.geom.Point2D;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

import Model.Direction.InitType;

// TODO: Auto-generated Javadoc
/*		// a teszteset 3ban nem erdekes hogy van-e alatta terep, ezert nem
 // kerdezunk ra
 // ha van alatta vagy ha nincs alatta akkor is ugyanugy fut le a
 // szekvencia
 // (nem kerdezunk ra a felhasznalotol)
 if (dir.getAngle() == 0.0 && dir.getLength() == 10.0)
 field.isThereField(new Point(0, 0));

 // Ha lefele mozog a bbu, akkor megnzzk, van-e ott terep (nem
 // krdeznk r a felhasznltl)
 if (dir.getAngle() == 270.0 && dir.getLength() == 10.0)
 field.isThereField(new Point(0, 0));

 // Az 5. tesztesetben csak all egyhelyben a babu, nem mozdul. Itt ugye
 // termeszetes hogy
 // van alatta talaj, nem kerdezunk ra a felhasznalotol.
 if (dir.getAngle() == 0.0 && dir.getLength() == 0.0) {
 field.isThereField(new Point(0, 0));
 }

 // A 6. teszesetben ra kell kerdezni hogy van-e alatta talaj vagy nincs!
 if (dir.getAngle() == 180.0 && dir.getLength() == 10.0) {
 field.isThereField(new Point(3, 3));
 }

 // A 7. tesztesetben feltetelezzuk hogy van alatta talaj,
 // ezert nem kerdezzuk meg a felhasznalotol.
 if (dir.getAngle() == 180.0 && dir.getLength() == 20.0) {
 field.isThereField(new Point(0, 0));
 }

 */
/**
 * FullTile osztly.
 * 
 * Olyan csempe, amely tartalmaz terepet s olyan alakzatokat mellyel
 * interakciba tud lpni a bbu. Ebben a bbu tud mozogni. Kiszmolja a bbu
 * pontos elmozdulsnak irnyt s nagysgt a bbut krlvev tereptl
 * fggen. Meg tudja krdezni a terepet, hogy adott pontban terep van-e. Meg
 * tudja vizsglni, hogy illeszkedik-e egy msik csempvel, az alapjn, hogy a
 * bbu honnan hova akar elmozdulni.
 * 
 * @author Szab Csaba
 * @author Gerlei Balzs
 * @author Halsz Antal Istvn
 * @author Berki Ramna
 * @version 1.0
 */
public class FullTile extends Tile {
	/** A benne lv terep. */
	private ArrayList<Field> fields;

	/** Referencia a bbura, rtke null, ha a bbu nincs a csempben. */
	private Figure figureA;

	/** The figure b. */
	private Figure figureB;

	/**
	 * Csempe kereteit trol kollekci. A keretek trolsnak sorrendje fix:
	 * jobb oldali, fels, bal oldali, lenti.
	 * */
	private ArrayList<Frame> frames;

	/** A csempben lv kulcs(ok)at s/vagy kijratot trol tmb. */
	private ArrayList<GameObject> gameObjects;

	/**
	 * FullTile konstruktora. Ltrehoz egy j teli csempt.
	 * 
	 * @param myLevel
	 *            a szl level
	 * @param center
	 *            the center
	 * @param h
	 *            the h
	 * @param w
	 *            the w
	 */
	public FullTile(Level myLevel, Point center, int h, int w) {
		super(myLevel, center, h, w);

		// j terep ltrehozsa
		fields = new ArrayList<Field>();

		// Ltrehozunk res kereteket (keretekpontok belltsa az endFullTile
		// parancs hatsra trtnik)
		frames = new ArrayList<Frame>();
		for (int i = 0; i < 4; i++) {
			frames.add(new Frame());
		}

		// Hozzadunk egy kulcsot s egy kijratot
		gameObjects = new ArrayList<GameObject>();
		figureA = null;
		figureB = null;
	}

	/**
	 * Instantiates a new full tile.
	 * 
	 * @param myLevel
	 *            the my level
	 * @param coord
	 *            the coord
	 */
	public FullTile(Level myLevel, Point coord) {
		super(myLevel, coord);

		fields = new ArrayList<Field>();
		frames = new ArrayList<Frame>();
		gameObjects = new ArrayList<GameObject>();
		figureA = null;
		figureB = null;
	}

	/**
	 * Adds the field point.
	 * 
	 * @param fieldIndex
	 *            the field index
	 * @param p
	 *            the p
	 */
	public void addFieldPoint(int fieldIndex, Point p) {
		fields.get(fieldIndex).addPoint(p);
	}

	/**
	 * Visszaadja a bekrt bbu pontos elmozdulst a bbura hat pillanatnyi
	 * erhatsok figyelembevtelvel.
	 * 
	 * @param f
	 *            a bbu
	 * @param name
	 *            the name
	 * @param pw
	 *            the pw
	 * @return a kiszmolt j koordinta
	 */
	private Point calculateNewCoord(Figure f, String name, PrintWriter pw) {
		// Bbu koordintjnak lemsolsa
		Point2D.Double coord = new Point2D.Double(f.getCoord().getX(), f
				.getCoord().getY());
		// Bbu irnynak lekrdezse
		Direction dir = f.getDirection();
		boolean noDir = false;
		if (dir == null) {
			dir = new Direction();
			noDir = true;
		}
		// Bbu rgi irnynak lekrdezse
		Direction oldDir = f.getOldDirection();
		boolean noOldDir = false;
		if (oldDir == null) {
			oldDir = new Direction();
			noOldDir = true;
		}

		// megnzzk, talajon ll-e a bbu
		Field fi = null;
		boolean isGround = false;
		boolean wasGround = false;
		for (Field temp : fields) {
			if (temp.isThereField(new Point((int) coord.x, (int) (coord.y - 19))) == true) {
				fi = temp;
				isGround = true;
			}
		}

		// ered er szmts
		Direction resForce = null;
		Direction gravity = new Direction(0, -2, Direction.InitType.Coordinates);

		// ha adott simulate-ben van olyan felhasznli input, ami nem ugrs,
		// eltroljuk
		if ((int) dir.getX() != 0 && (int) dir.getY() == 0) {
			f.setLastTimeInput(true);
			Direction oDir = new Direction(dir);
			if (dir.getX() > 5)
				oDir.setX(5);
			else if (dir.getX() < -5)
				oDir.setX(-5);
			else
				;
			f.setOldInputDir(oDir);

		} else {
			// ha mr nem hat, s nem ugrs, akkor vegyk el az inputerhatst
			if (f.getLastTimeInput() == true && (int) dir.getY() == 0) {
				oldDir = oldDir.add(new Direction((int) -(f.getOldInputDir()
						.getX()), (int) -(f.getOldInputDir().getY()),
						Direction.InitType.Coordinates));
				f.setLastTimeInput(false);
			}
		}

		// ha talajon ll a bbu
		if (fi != null) {
			resForce = dir.add(oldDir);
			if ((int) Math.abs(resForce.getY()) == 0) {
				if (resForce.getX() > 5)
					resForce.setX(5);
				else if (resForce.getX() < -5)
					resForce.setX(-5);
				else
					;
			} else if ((int) dir.getY() != 0)
				resForce = resForce.add(gravity);
		} else {
			// ha nem ll talajon a bbu
			if ((int) Math.abs(dir.getY()) == 0) {
				resForce = oldDir.add(gravity).add(dir);
			} else {
				resForce = oldDir.add(gravity);
			}
			if ((int) Math.abs(dir.getAngle()) == 0 && noDir == false
					&& Math.abs(dir.getLength()) >= 0.001) {
				resForce = resForce.add(new Direction(0.5, 0,
						Direction.InitType.Coordinates));
			} else if ((int) Math.abs(dir.getAngle()) == 180 && noDir == false
					&& Math.abs(dir.getLength()) >= 0.001) {
				resForce = resForce.add(new Direction(-0.5, 0,
						Direction.InitType.Coordinates));
			} else
				;
		}
		// hogy ne gyorsulhassunk tl
		if (resForce.getLength() > 10 && resForce.getY() < 0) {
			resForce.setLength(10);
		}
		/*
		 * // megnzzk, hogy elkezdett-e ugrani vagy esni if ((int)
		 * resForce.getY() > 0 && (int) oldDir.getY() <= 0) { if (pw != null)
		 * pw.println(name + " elkezdett ugrani."); } else if ((int)
		 * resForce.getY() < 0 && (int) oldDir.getY() >= 0) { if (pw != null)
		 * pw.println(name + " elkezdett zuhanni."); } else ;
		 */
		// ha mozgunk, megnzzk, hogy mozgs kzben az utunkba akad-e valami
		if ((int) Math.abs(resForce.getX()) != 0
				|| (int) Math.abs(resForce.getY()) != 0) {
			Direction unitForce = new Direction(resForce.getX()
					/ resForce.getLength(), resForce.getY()
					/ resForce.getLength(), Direction.InitType.Coordinates);
			Point2D.Double dest = new Point2D.Double(coord.x + resForce.getX(),
					coord.y + resForce.getY());
			boolean wall = false;
			boolean frame = false;
			int numOfRounds = 0;
			Point2D.Double nextCoord = null;
			GameObject foundThisSession = null;
			// alapveten buta szmts, ha falnak tkznk, nem esnk semerre
			// tovbb, ha kifogy a lbunk all a talaj, esni kezdnk
			do {
				nextCoord = new Point2D.Double(coord.x + unitForce.getX(),
						coord.y + unitForce.getY());
				++numOfRounds;
				// keretnek tkzs vizsglata
				for (Frame fr : frames) {
					if (fr.checkFrame(new Point((int) nextCoord.x,
							(int) nextCoord.y)) == true) {
						frame = true;
						break;
					}
				}
				// falnak tkzs vizsglata
				for (Field temp : fields) {
					// jobbra
					if (temp.isThereField(new Point((int) nextCoord.x + 5,
							(int) nextCoord.y)) == true) {
						if (pw != null)
							pw.println(name + " falnak utkozott!");
						wall = true;
						break;
					}
					// fel
					if (temp.isThereField(new Point((int) nextCoord.x,
							(int) nextCoord.y + 18)) == true) {
						if (pw != null)
							pw.println(name + " falnak utkozott!");
						wall = true;
						break;
					}
					// balra
					if (temp.isThereField(new Point((int) nextCoord.x - 5,
							(int) nextCoord.y)) == true) {
						if (pw != null)
							pw.println(name + " falnak utkozott!");
						wall = true;
						break;
					}
					// talaj
					wasGround = isGround;
					if (temp.isThereField(new Point((int) nextCoord.x,
							(int) nextCoord.y - 18)) == true) {
						if (pw != null)
							pw.println(name + " talajnak utkozott!");
						wall = true;
						isGround = true;
						break;
					} else if (temp.isThereField(new Point((int) nextCoord.x,
							(int) nextCoord.y - 19)) == true) {
						isGround = true;
						break;
					} else {
						isGround = false;
					}
				}
				if (frame == true) {
					coord = nextCoord;
					break;
				}
				if (wall == true) {
					break;
				} else {
					coord = nextCoord;
					// ha eltnt alla a talaj, elkezd esni
					if (wasGround == true && isGround == false) {
						// hat r a gravitci
						resForce = resForce.add(gravity);
						// j lesz az egysgnyi elmozduls
						unitForce = new Direction(resForce.getX()
								/ resForce.getLength(), resForce.getY()
								/ resForce.getLength(),
								Direction.InitType.Coordinates);
						Direction unitForceOpposite = new Direction(
								-resForce.getX() / resForce.getLength(),
								-resForce.getY() / resForce.getLength(),
								Direction.InitType.Coordinates);
						// megrvidtjk az erhatst annyival, amennyit mr az
						// eredeti irnyban haladtunk
						for (int i = 0; i < numOfRounds; ++i) {
							resForce = resForce.add(unitForceOpposite);
						}
						// j lesz a cl is
						dest = new Point2D.Double(coord.x + resForce.getX(),
								coord.y + resForce.getY());

						// biztos, hogy elkezdett esni
						if (pw != null)
							pw.println(name + " elkezdett zuhanni.");
					}
					// vizsglunk GameObjectekre, s interact
					GameObject go = findGameObject(new Point((int) coord.x,
							(int) coord.y));
					if (go != null) {
						if (foundThisSession == null
								|| foundThisSession.equals(go) == false) {
							if (go.interact(f, name, pw) == true) {
								myLevel.finished(pw);
								return new Point((int) coord.x, (int) coord.y);
							}
							foundThisSession = go;
						}
					}
				}
			} while ((Math.abs(dest.x - coord.x) > 0.5 || Math.abs(dest.y
					- coord.y) > 0.5));

			// ha falnak mentnk, vltozik az elmozdulsvektor
			if (wall == true) {
				// beragads kikszblse
				boolean stillWall = true;
				while (stillWall == true) {
					stillWall = false;
					for (Field temp : fields) {
						// jobbra
						if (temp.isThereField(new Point((int) coord.x + 5,
								(int) coord.y - 1)) == true) {
							stillWall = true;
							coord.x -= 1;
							break;
						}
						// fel
						if (temp.isThereField(new Point((int) coord.x + 1,
								(int) coord.y + 18)) == true) {
							stillWall = true;
							coord.y -= 1;
							break;
						}
						// balra
						if (temp.isThereField(new Point((int) coord.x - 5,
								(int) coord.y - 1)) == true) {
							stillWall = true;
							coord.x += 1;
							break;
						}
					}
				}
				// elmozdulsvektor lltsa
				if (resForce.getAngle() > 315 || resForce.getAngle() <= 45) {
					resForce.setX(0);
					f.setOldInputDir(new Direction());
				} else if (resForce.getAngle() > 45
						&& resForce.getAngle() <= 135) {
					resForce.setY(0);
					f.setOldInputDir(new Direction());
				} else if (resForce.getAngle() > 135
						&& resForce.getAngle() <= 225) {
					resForce.setX(0);
					f.setOldInputDir(new Direction());
				} else {
					resForce.setY(0);
					resForce.setX(0);
					f.setOldInputDir(new Direction());
				}
			}
		}
		f.setOldDirection(resForce);
		return new Point((int) coord.x, (int) coord.y);
	}

	/**
	 * Az 1. bbu kvnt elmozdulsnak belltsrt felels fggvny.
	 * 
	 * @param dir
	 *            az elmozduls irnya
	 */
	public void changeFigureADirection(Direction dir) {
		try {
			figureA.setDirection(dir);
		} catch (NullPointerException e) {
			System.out.println("FigureA nem ebben a csempeben van!");
		}
	}

	/**
	 * A 2. bbu kvnt elmozdulsnak belltsrt felels fggvny.
	 * 
	 * @param dir
	 *            az elmozduls irnya
	 */
	public void changeFigureBDirection(Direction dir) {
		try {
			figureB.setDirection(dir);
		} catch (NullPointerException e) {
			System.out.println("FigureB nem ebben a csempeben van!");
		}
	}

	/**
	 * Megvltoztatja a csempe helyt, visszaadja a csempe rgi helyt.
	 * 
	 * @param coord
	 *            a csempe j koordintja
	 * @return a csempe rgi kordintja
	 */
	public Point changePosition(Point coord) {

		Point tileCoord = this.getTileIndex();
		this.setTileIndex(coord);

		return tileCoord;
	}

	/**
	 * Visszaadja azt a GameObject objektumot, ami a kiszmtott elmozduls
	 * helyn tallhat. Ha nincs ott objektum, vagy a csempe nem tartalmaz
	 * GameObjecteket, visszatrsi rtke null.
	 * 
	 * @param coord
	 *            the coord
	 * @return a tallt GameObject. Ha nincs, akkor null.
	 */
	private GameObject findGameObject(Point coord) {
		// Vgignzi a GameObjectek tmbjt hogy egyezik-e valamelyik
		// koordintja valamelyik figurval. Ha tall ilyet, akkor azt
		// visszaadja.
		for (GameObject go : gameObjects) {
			if (Math.abs(go.getCoord().x - coord.x) < 26
					&& Math.abs(go.getCoord().y - coord.y) < 26) {
				return go;
			}
		}
		return null;
	}

	/**
	 * Visszaadja a terepeket tartalmaz gyjtemnyt.
	 * 
	 * @return Referencia a terepek gyjtemnyre.
	 */
	public ArrayList<Field> getFields() {
		return fields;
	}

	/**
	 * Gets the figure a.
	 * 
	 * @return the figure a
	 */
	public Figure getFigureA() {
		return figureA;
	}

	/**
	 * Gets the figure b.
	 * 
	 * @return the figure b
	 */
	public Figure getFigureB() {
		return figureB;
	}

	/**
	 * Visszaadja a bekrt oldalon lv keretet.
	 * 
	 * @param dir
	 *            a krt irny
	 * @return a keret
	 */
	public Frame getFrame(Direction dir) {

		// Visszaadja a megfelel irnyban lev keretet
		if (dir.getAngle() == 0.0) {
			return frames.get(0);
		} else if (dir.getAngle() == 90.0) {
			return frames.get(1);
		} else if (dir.getAngle() == 180.0) {
			return frames.get(2);
		} else if (dir.getAngle() == 270.0) {
			return frames.get(3);
		} else {
			return null; // ha fos koordintt kap vletlenl, akkor mit
							// csinljunk?
							// szerintem pont ezt (Shanti)
		}

	}

	/**
	 * Gets the frames.
	 * 
	 * @return the frames
	 */
	public ArrayList<Frame> getFrames() {
		return frames;
	}

	/**
	 * Visszaadja a game objecteket tartalmaz gyjtemnyt..
	 * 
	 * @return referencia a game objecteket tartalmaz gyjtemnyre.
	 */
	public ArrayList<GameObject> getGameObjects() {
		return gameObjects;
	}

	/**
	 * Megmondja, hogy az 1. bbu a csempben van-e.
	 * 
	 * @return igaz, ha az 1. bbu a csempben van
	 */
	public boolean isThereFigureA() {
		return figureA == null ? false : true;
	}

	/**
	 * Megmondja, hogy a 2. bbu a csempben van-e.
	 * 
	 * @return igaz, ha a 2. bbu a csempben van
	 */
	public boolean isThereFigureB() {
		return figureB == null ? false : true;
	}

	/**
	 * Kiszmtja az adott bbu pontos elmozdulst.
	 * 
	 * @param f
	 *            a mozgatand figura
	 * @param name
	 *            the name
	 * @param pw
	 *            the pw
	 * @return a pont, ahova az adott bbu kerlt
	 */
	public Point moveFigure(Figure f, String name, PrintWriter pw) {
		// a bbu elmozdulsa
		Point newCoord = calculateNewCoord(f, name, pw);
		/*
		 * System.out.println("oldCoord: " + f.getCoord().x + "," +
		 * f.getCoord().y + " newCoord: " + newCoord.x + "," + newCoord.y);
		 */
		// keret vizsglat
		boolean isThereFrame = false;
		for (Frame fr : frames) {
			if (fr.checkFrame(newCoord) == true) {
				isThereFrame = true;
			}
		}

		// ha van keret, elkrjk a megfelel szomszdot,
		// s megnzzk, hogy t tudunk-e menni. Ha igen, akkor t is megynk,
		// ha nem, akkor esettl fggen maradunk a helynkn vagy meghalunk.
		FullTile neighbourFullTile = null;
		if (isThereFrame == true) {
			// ha az x koordinta rte el a keretet
			if (newCoord.y > 18 && newCoord.y < 382) {
				if (newCoord.x > 495) {
					neighbourFullTile = myLevel.getNeighbour(new Direction(0,
							1, Direction.InitType.Angle), this.getTileIndex());
					if (neighbourFullTile != null
							&& neighbourFullTile.getFrame(
									new Direction(180, 1,
											Direction.InitType.Angle)).match(
									frames.get(0))) {
						f.setMyTile(neighbourFullTile);
						newCoord = new Point(10, newCoord.y);
						if (figureA != null && figureA.equals(f)) {
							figureA = null;
							neighbourFullTile.setFigureA(f);
						} else if (figureB != null && figureB.equals(f)) {
							figureB = null;
							neighbourFullTile.setFigureB(f);
						} else
							;
						if (pw != null)
							pw.println(name
									+ " atmegy Kelet iranyban egy masik csempebe.");
					} else {
						f.getOldDirection().setX(0);
						f.setLastTimeInput(false);
						newCoord.x = 495;
						if (pw != null)
							pw.println(name
									+ " Kelet iranyban nem tudja elhagyni a csempet!");
					}
				} else if (newCoord.x < 10) {
					neighbourFullTile = myLevel.getNeighbour(new Direction(180,
							1, Direction.InitType.Angle), this.getTileIndex());
					if (neighbourFullTile != null
							&& neighbourFullTile.getFrame(
									new Direction(0, 1,
											Direction.InitType.Angle)).match(
									frames.get(2))) {
						f.setMyTile(neighbourFullTile);
						newCoord = new Point(495, newCoord.y);
						if (figureA != null && figureA.equals(f)) {
							figureA = null;
							neighbourFullTile.setFigureA(f);
						} else if (figureB != null && figureB.equals(f)) {
							figureB = null;
							neighbourFullTile.setFigureB(f);
						} else
							;
						if (pw != null)
							pw.println(name
									+ " atmegy Nyugat iranyban egy masik csempebe.");
					} else {
						f.getOldDirection().setX(0);
						f.setLastTimeInput(false);
						newCoord.x = 10;
						if (pw != null)
							pw.println(name
									+ " Nyugat iranyban nem tudja elhagyni a csempet!");
					}
				} else
					;
				// ha mindkt vagy az y koordinta rte el a keretet
			} else {
				if (newCoord.x < 10) {
					newCoord.x = 10;
				} else if (newCoord.x > 495) {
					newCoord.x = 495;
				}

				if (newCoord.y > 381) {
					neighbourFullTile = myLevel.getNeighbour(new Direction(90,
							1, Direction.InitType.Angle), this.getTileIndex());
					if (neighbourFullTile != null
							&& neighbourFullTile.getFrame(
									new Direction(270, 1,
											Direction.InitType.Angle)).match(
									frames.get(1))) {
						f.setMyTile(neighbourFullTile);
						newCoord = new Point(newCoord.x, 19);
						if (figureA != null && figureA.equals(f)) {
							figureA = null;
							neighbourFullTile.setFigureA(f);
						} else if (figureB != null && figureB.equals(f)) {
							figureB = null;
							neighbourFullTile.setFigureB(f);
						} else
							;
						if (pw != null)
							pw.println(name
									+ " atmegy Eszak iranyban egy masik csempebe.");
					} else {
						f.getOldDirection().setY(0);
						f.setLastTimeInput(false);
						newCoord.y = 382;
						if (pw != null)
							pw.println(name
									+ " Eszak iranyban nem tudja elhagyni a csempet!");
					}
				} else if (newCoord.y < 19) {
					neighbourFullTile = myLevel.getNeighbour(new Direction(270,
							1, Direction.InitType.Angle), this.getTileIndex());
					if (neighbourFullTile != null
							&& neighbourFullTile.getFrame(
									new Direction(90, 1,
											Direction.InitType.Angle)).match(
									frames.get(3))) {
						f.setMyTile(neighbourFullTile);
						newCoord = new Point(newCoord.x, 381);
						if (figureA != null && figureA.equals(f)) {
							figureA = null;
							neighbourFullTile.setFigureA(f);
						} else if (figureB != null && figureB.equals(f)) {
							figureB = null;
							neighbourFullTile.setFigureB(f);
						} else
							;
						if (pw != null)
							pw.println(name
									+ " atmegy Del iranyban egy masik csempebe.");
					} else {
						f.setOldDirection(new Direction());
						if (figureA != null && figureA.equals(f)) {
							figureA = null;
							f.setMyTile((FullTile) myLevel.getTiles().get(
									myLevel.getFigureAStartTileIndex()));
							newCoord = myLevel.getFigureAStartCoord();
							f.getMyTile().setFigureA(f);
							if (pw != null)
								pw.println("FigureA meghalt, majd a "
										+ myLevel.getFigureAStartCoord().x
										+ " "
										+ myLevel.getFigureAStartCoord().y
										+ " koordinatan ujraeledt.");
						} else if (figureB != null && figureB.equals(f)) {
							figureB = null;
							f.setMyTile((FullTile) myLevel.getTiles().get(
									myLevel.getFigureBStartTileIndex()));
							newCoord = myLevel.getFigureBStartCoord();
							f.getMyTile().setFigureB(f);
							if (pw != null)
								pw.println("FigureB meghalt, majd a "
										+ myLevel.getFigureBStartCoord().x
										+ " "
										+ myLevel.getFigureBStartCoord().y
										+ " koordinatan ujraeledt.");
						} else
							;
					}
				} else
					;
			}
		}

		return newCoord;
	}

	/**
	 * Belltja az 1. bbu referencijt.
	 * 
	 * @param fA
	 *            a belltand bbu
	 */
	public void setFigureA(Figure fA) {
		figureA = fA;
	}

	/**
	 * Belltja a 2. bbu referencijt.
	 * 
	 * @param fB
	 *            a belltand bbu
	 */
	public void setFigureB(Figure fB) {
		figureB = fB;
	}

	/**
	 * Idkezels tovbbadsa az 1. bbunak.
	 * 
	 * @param dt
	 *            the dt
	 * @param name
	 *            the name
	 * @param pw
	 *            the pw
	 */
	public void simulateFigureAWorld(int dt, String name, PrintWriter pw) {
		try {
			figureA.move(dt, name, pw);
		} catch (NullPointerException e) {
			System.out.println("FigureA nem ebben a csempeben van!");
		}
	}

	/**
	 * Idkezels tovbbadsa a 2. bbunak.
	 * 
	 * @param dt
	 *            the dt
	 * @param name
	 *            the name
	 * @param pw
	 *            the pw
	 */
	public void simulateFigureBWorld(int dt, String name, PrintWriter pw) {
		try {
			figureB.move(dt, name, pw);
		} catch (NullPointerException e) {
			System.out.println("FigureB nem ebben a csempeben van!");
		}
	}
}
