package Model;

import java.awt.Point;
import java.io.PrintWriter;

// TODO: Auto-generated Javadoc
/**
 * GameObject osztly.
 * 
 * Ez az absztrakt osztly kezeli a bbu zsebt. Megmondja, hogy a vele trtn
 * rintkezs hatsra a plya teljestett lett-e
 * 
 * @author Szab Csaba
 * @author Gerlei Balzs
 * @author Halsz Antal Istvn
 * @author Berki Ramna
 * @version 1.0
 */
public abstract class GameObject {
	/** Megmondja, hol helyezkedik el a GameObject. */
	private Point coord;

	/** The my tile. */
	private FullTile myTile;

	/**
	 * GameObject konstruktora. Ltrehoz egy j GameObjectet.
	 *
	 * @param point the point
	 */
	public GameObject(Point point, FullTile tile) {
		coord = point;
		myTile = tile;
	}

	/**
	 * Visszaadja a koordintjt.
	 * 
	 * @return GameObject koordintja
	 */
	public Point getCoord() {
		return coord;
	}
	
	/**
	 * Gets the my tile.
	 *
	 * @return the my tile
	 */
	public FullTile getMyTile() {
		return myTile;
	}

	/**
	 * Interactol a kapott figurval.
	 *
	 * @param f the f
	 * @param name the name
	 * @param pw the pw
	 * @return igaz, ha kijratot tallt, s vge a jtknak.
	 */
	public boolean interact(Figure f, String name, PrintWriter pw) {
		return false;
	}

	/**
	 * Belltja a koordintjt.
	 * 
	 * @param point
	 *            a belltand j koordinta
	 */
	public void setCoord(Point point) {
		// Koordinta belltsa
		coord = point;
	}

	/**
	 * A modell beli koordintt a kirajzolsnak megfelel
	 * koordinta-rendszerbe vltja t.
	 * 
	 * @return kirajzolshoz hasznlhat koordinta
	 */
	public Point transformToMatrixCoord() {
		return new Point(coord.x, 400 - coord.y);
	}
	
	/**
	 * What is it.
	 *
	 * @return the type
	 */
	public abstract Type whatIsIt();
}