package Model;

import java.awt.Point;
import java.io.PrintWriter;
import java.util.ArrayList;

/**
 * Key osztly.
 * 
 * A szint teljestshez szksges. Amikor a bbu elri a kulcsot, akkor a 
 * kulcs beteszi nmagt a bbu zsebbe. Meg tudja mondani, hogy felvettk-e.
 * 
 * @author Szab Csaba
 * @author Gerlei Balzs
 * @author Halsz Antal Istvn
 * @author Berki Ramna
 * @version 1.0
 */
public class Key extends GameObject {
	/** Megmondja, hogy felvettk-e mr. */
	private boolean pickedUp;

	/**
	 * Key konstruktora. Ltrehoz egy j kulcsot.
	 */
	public Key(Point point, FullTile tile) {
		super(point, tile);
		pickedUp = false;
	}

	/**
	 * Visszaadja, hogy felvettk-e mr.
	 * 
	 * @return igaz, ha fel lett mr vve
	 */
	public boolean isPickedUp() {
		// Ha fel lett vve, akkor igazat ad vissza, egybknt hamisat
		if (pickedUp) {
			return true;
		}
		return false;
	}

	/**
	 * Interactol a paramterknt kapott figura zsebvel (beteszi magt).
	 * 
	 * @return mindig hamis.
	 */
	public boolean interact(Figure f,String name, PrintWriter pw) {
		
		ArrayList<Key> pocket = f.getPocket();
		for(Key k : pocket){
			if(this.equals(k))
				return false;
		}
		
		pocket.add(this);
		pickedUp=true;
		if(pw!=null)
			pw.println(name +" kulcsot talalt.");
		return false;
	}

	@Override
	public Type whatIsIt() {
		return Type.Key;
	}
}
