package View;

import javax.swing.*;

import Model.Field;
import Model.FullTile;

import java.awt.*;

// TODO: Auto-generated Javadoc
/**
 * The Class FullTileView.
 */
public class FullTileView extends Canvas implements IPaintable {

	/** The my full tile. */
	private FullTile myFullTile;

	/** The my view. */
	private View myView;

	/**
	 * Instantiates a new full tile view.
	 * 
	 * @param ft
	 *            the ft
	 * @param v
	 *            the v
	 */
	public FullTileView(FullTile ft, View v) {
		myFullTile = ft;
		myView = v;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.awt.Canvas#paint(java.awt.Graphics)
	 */
	@Override
	public void paint(Graphics g) {
		Graphics2D g2d = (Graphics2D) g;
		int dimensionX = myView.getMyLevel().getX();
		int dimensionY = myView.getMyLevel().getY();
		Point center = myFullTile.getTileIndex();

		// kiszmoljuk a csempe bal fels sark
		// TODO perpill kicsit pontatlan, ha ltjuk, majd helyesbtjk minden
		// osztlyban
		int xBound = (800 / dimensionY * center.y) - (800 / dimensionY);
		int yBound = (600 / dimensionX * center.x) - (600 / dimensionX);
		this.setBounds(xBound, yBound, 500, 400);

		// scale belltsa
		g2d.scale(myView.getScale(), myView.getScale());
		// csempe kirajzolsa
		g2d.setColor(Color.BLACK);
		g2d.drawRect((int) (this.getX() / myView.getScale()),
				(int) (this.getY() / myView.getScale()), this.getWidth(),
				this.getHeight());
		g2d.setColor(Color.WHITE);
		g2d.fillRect((int) (this.getX() / myView.getScale()),
				(int) (this.getY() / myView.getScale()), this.getWidth(),
				this.getHeight());
		// A terepalakzatok kirajzolsa
		g2d.setColor(new Color(255, 51, 204));
		for (Field f : myFullTile.getFields()) {
			int[] ymod = new int[f.getFieldPoints().npoints];
			for (int i = 0; i < f.getFieldPoints().npoints; ++i) {
				ymod[i] = 400 - f.getFieldPoints().ypoints[i];
			}
			Polygon p = new Polygon(f.getFieldPoints().xpoints, ymod,
					f.getFieldPoints().npoints);
			p.translate((int) (xBound / myView.getScale()),
					(int) (yBound / myView.getScale()));
			g2d.fillPolygon(p);
		}

		// scale visszallts
		g2d.scale(1 / myView.getScale(), 1 / myView.getScale());

	}

}
