package View;

import javax.swing.*;

import Model.*;

import java.awt.*;
import java.util.ArrayList;

// TODO: Auto-generated Javadoc
/**
 * The Class View.
 */
public class View extends JPanel {

	/** The components. */
	private ArrayList<IPaintable> components;

	/** The my level. */
	private Level myLevel;

	/** The scale. */
	private double scale;

	/**
	 * Instantiates a new view.
	 * 
	 * @param level
	 *            the level
	 */
	public View(Level level, JFrame frame) {
		
		components = new ArrayList<IPaintable>();
		
		myLevel = level;
		if (myLevel.getY() == 2) {
			scale = 0.7;
		} else if (myLevel.getY() == 3) {
			scale = 0.5;
		} else if (myLevel.getY() == 4) {
			scale = 0.3;
		} else {
			scale = 0.3;
		}
		// TODO
		// View-k ltrehozsnak sorrendje: FullTileView, ExitView, KeyView,
		// FigureView (B, majd A bbuhoz)
		Figure a = null;
		Figure b = null;
		ArrayList<GameObject> GameObjectList = new ArrayList<GameObject>();
		//csempk pars-olsa
		for (int i = 1; i < myLevel.getTiles().size(); ++i) {
			FullTile ft = (FullTile) myLevel.getTiles().get(i);
			// elmentjk a benne tallhat komponenseket ksbbi hasznlatra
			if (ft.isThereFigureA() == true) {
				a = ft.getFigureA();
			}
			if (ft.isThereFigureB() == true) {
				b = ft.getFigureB();
			}
			if (ft.getGameObjects().size() > 0) {
				for (GameObject go : ft.getGameObjects()) {
					GameObjectList.add(go);
				}
			}
			// ltrehozzuk, s hozzadjuk a komponenslisthoz a View-jt
			components.add(new FullTileView(ft, this));
		}

		for (GameObject go : GameObjectList) {
			if (go.whatIsIt() == Type.Exit) {
				components.add(new ExitView((Exit) go, this));
			} else if (go.whatIsIt() == Type.Key) {
				components.add(new KeyView((Key) go, this));
			} else {
				System.out.println("GameObject View error");
			}
		}
		if(b!=null){
			components.add(new FigureView(b, this, Type.FigureB));
		}
		if(a!=null){
			components.add(new FigureView(a, this, Type.FigureA));
		}
		
		this.setBounds(0, 0, 800, 600);
		frame.getContentPane().add(this);
	}

	/**
	 * Gets the my level.
	 * 
	 * @return the my level
	 */
	public Level getMyLevel() {
		return myLevel;
	}

	/**
	 * Gets the scale.
	 * 
	 * @return the scale
	 */
	public double getScale() {
		return scale;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
	 */
	@Override
	public void paintComponent(Graphics g) {
		super.paintComponent(g);
		// Minden komponens paint fggvnynek meghvsa egyms utn
		for (IPaintable p : components) {
			p.paint(g);
		}

	}

}
